if not Recount then return end
local Recount = Recount
local RecountMitigation = LibStub("AceAddon-3.0"):NewAddon("RecountMitigation", "AceEvent-3.0", "AceTimer-3.0")
RecountMitigation.Version = 5.1
local RL = LibStub("AceLocale-3.0"):GetLocale("Recount")
local L = LibStub("AceLocale-3.0"):GetLocale("RecountMitigation")

local mBuffAll = {
	[31850] = 0.20, -- Ardent Defender
	[65116] = 0.10, -- Stoneform
	[54924] = 0.20, -- Glyph of Divine Protection (UNTESTED)
}
local mBuffPhysical = {
	[132403] = 0.30, -- Shield of the Righteous (Base Mitigation - Actual mitigation worked out later)
}
local mBuffMagical = {
	[498]   = 0.40,	-- Divine Protection
	[31821] = 0.20,	-- Devotion Aura
}
local mBuffAllHTD = {
	[86659] = 0.50, -- Guardian of Ancient Kings
}
local mBuffPhysicalHTD = {
}
local mBuffMagicalHTD = {
}
local mBuffs = {}
for k, v in pairs(mBuffAll) do mBuffs[k] = v end
for k, v in pairs(mBuffPhysical) do mBuffs[k] = v end
for k, v in pairs(mBuffMagical) do mBuffs[k] = v end
local mBuffsHTD = {}
for k, v in pairs(mBuffAllHTD) do mBuffsHTD[k] = v end
for k, v in pairs(mBuffPhysicalHTD) do mBuffsHTD[k] = v end
for k, v in pairs(mBuffMagicalHTD) do mBuffsHTD[k] = v end

local SPELLSCHOOL_PHYSICAL = 1
local SPELLSCHOOL_HOLY = 2
local SPELLSCHOOL_FIRE = 4
local SPELLSCHOOL_NATURE = 8
local SPELLSCHOOL_NATUREFIRE = SPELLSCHOOL_FIRE + SPELLSCHOOL_NATURE
local SPELLSCHOOL_FROST = 16
local SPELLSCHOOL_FROSTFIRE = SPELLSCHOOL_FIRE + SPELLSCHOOL_FROST
local SPELLSCHOOL_SHADOW = 32
local SPELLSCHOOL_ARCANE = 64

local DetailTitles={}
DetailTitles.DamageMitigation={
	TopNames = RL["Ability Name"],
	TopCount = RL["Count"],
	TopAmount = RL["Damage"],
	BotNames = L["Protected"],
	BotMin = RL["Min"],
	BotAvg = RL["Avg"],
	BotMax = RL["Max"],
	BotAmount = RL["Count"]
}
DetailTitles.DamageReducedBy={
	TopNames = RL["Ability Name"],
	TopCount = RL["Count"],
	TopAmount = RL["Damage"],
	BotNames = RL["Player/Mob Name"],
	BotMin = RL["Min"],
	BotAvg = RL["Avg"],
	BotMax = RL["Max"],
	BotAmount = RL["Count"]
}

local mActive={}
local HTD={}
local Epsilon=0.000000000000000001

function RecountMitigation:OnInitialize()
end
function RecountMitigation:OnEnable()
	if not Recount then return end
	RecountMitigation:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "CombatLogEvent")
	RecountMitigation:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED", "mEventHTD")
end
function RecountMitigation:OnDisable()
	RecountMitigation:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end

------------------
-- MELEE DAMAGE	--
------------------
function RecountMitigation:MeleeDamage(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing)
	RecountMitigation:SortDR(srcName, dstName, RL["Melee"], SPELLSCHOOL_PHYSICAL, amount, 0, timestamp, absorbed, blocked, resisted)
end
------------------
-- MELEE MISS	--
------------------
function RecountMitigation:MeleeMiss(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, missType, missAmount, missAmountNew)
	RecountMitigation:SortDR(srcName, dstName, RL["Melee"], SPELLSCHOOL_PHYSICAL, 0, 0, timestamp, missAmountNew, nil, nil)
end
------------------
-- SPELL DAMAGE	--
------------------
function RecountMitigation:SpellDamage(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags,spellId, spellName, spellSchool, amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing)
	if eventtype == "RANGE_DAMAGE" then spellSchool = school end
	if eventtype == "SPELL_PERIODIC_DAMAGE" then
		spellName = spellName .." ("..RL["DoT"]..")"
	end
	RecountMitigation:SortDR(srcName, dstName, spellName, spellSchool, amount, spellId, timestamp, absorbed, blocked, resisted)
end
------------------
-- SPELL MISS	--
------------------
function RecountMitigation:SpellMiss(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, spellId, spellName, spellSchool, missType, missAmount, missAmountNew)
	if eventtype == "RANGE_MISSED" then spellSchool = school end
		if eventtype == "SPELL_PERIODIC_MISSED" then
			spellName = spellName .." ("..RL["DoT"]..")"
		end
	RecountMitigation:SortDR(srcName, dstName, spellName, spellSchool, 0, spellId, timestamp, missAmountNew, nil, nil)
end
------------------
-- ENVIROMENTAL	--
------------------
function RecountMitigation:EnvironmentalDamage(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, enviromentalType, amount, overkill, school, resisted, blocked, absorbed, critical, glancing, crushing)
	RecountMitigation:SortDR("Environment", dstName, Recount:FixCaps(enviromentalType), school, amount, spellId, timestamp, absorbed, blocked, resisted)
end
----------------------------------------------------------------------
--																	--
--  FUNCTION : MITIGATION BUFF APPLIED								--
--																	--
----------------------------------------------------------------------
function RecountMitigation:mBuffApplied(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, spellId, spellName, spellSchool, auraType, amount)
	if not mBuffs[spellId] and not mBuffsHTD[spellId] then return end
	if UnitIsUnit(dstName, "player") then dstName = UnitName("player") end
	if UnitIsUnit(srcName, "player") then srcName = UnitName("player") end

	--REMOVE BUFF LATER
	if mBuffsHTD[spellId] then
		HTD["timestamp"] = timestamp
		HTD["dstName"] = dstName
		HTD["spellId"] = spellId
		HTD["spellName"] = spellName
		HTD["srcName"] = ''
		HTD["timer"]=RecountMitigation:ScheduleTimer("mBuffRemoved", 12, "HTD")
	end
	
	mActive[dstName] = mActive[dstName] or {}
	-- If buff is applied and its a HTD buff
	if mActive[dstName][spellId] and mBuffsHTD[spellId] then
		--Cancel Timer and Set it again
		RecountMitigation:CancelTimer(HTD["timer"], false)
		HTD["timer"]=RecountMitigation:ScheduleTimer("mBuffRemoved", 12, "HTD")
	end
	--print("Add:mActive[", dstName, "][", spellId, "] = ", timestamp)
	mActive[dstName][spellId] = timestamp
end
----------------------------------------------------------------------
--																	--
--  FUNCTION : MITIGATION BUFF REMOVED								--
--																	--
----------------------------------------------------------------------
function RecountMitigation:mBuffRemoved(timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags,spellId, spellName, spellSchool, auraType, amount)
	if timestamp == "HTD" then
		--print("been 12secs")
		timestamp = HTD["timestamp"]
		dstName = HTD["dstName"]
		spellId = HTD["spellId"]
		spellName = HTD["spellName"]
	end
	if not mBuffs[spellId] and not mBuffsHTD[spellId] then return end
	
	--print("RemoveDRBuff- timestamp:", timestamp, " dstName:", dstName, "spellId:", spellId, "spellName:", spellName)
	--RecountMitigation:RemoveDRBuff(timestamp, dstName, spellId, spellName, '')
	
	local dstDRBuffs = mActive[dstName]
	if not dstDRBuffs or not dstDRBuffs[spellId] then return end
	--print("Remove:mActive[", dstName, "][", spellId, "] = ", nil)
	mActive[dstName][spellId] = nil
end

local mEvent =
{
	["SWING_DAMAGE"]			= RecountMitigation.MeleeDamage,
	["SWING_MISSED"]			= RecountMitigation.MeleeMiss,
	["RANGE_DAMAGE"]			= RecountMitigation.SpellDamage,
	["RANGE_MISSED"]			= RecountMitigation.SpellMiss,
	["SPELL_DAMAGE"]			= RecountMitigation.SpellDamage,
	["SPELL_MISSED"]			= RecountMitigation.SpellMiss,
	["SPELL_PERIODIC_DAMAGE"]	= RecountMitigation.SpellDamage,
	["SPELL_PERIODIC_MISSED"]	= RecountMitigation.SpellMiss,
	["DAMAGE_SHIELD"]			= RecountMitigation.SpellDamage,
	["DAMAGE_SPLIT"]			= RecountMitigation.SpellDamage,
	["ENVIRONMENTAL_DAMAGE"]	= RecountMitigation.EnvironmentalDamage,
	["SPELL_AURA_APPLIED"]		= RecountMitigation.mBuffApplied,
	["SPELL_AURA_REFRESH"]		= RecountMitigation.mBuffApplied,
	["SPELL_AURA_REMOVED"]		= RecountMitigation.mBuffRemoved,
}

local mEventList
----------------------------------------------------------------------
--																	--
--  FUNCTION : COMBAT LOG EVENT										--
--																	--
----------------------------------------------------------------------
function RecountMitigation:CombatLogEvent(_,timestamp, eventtype, hideCaster, srcGUID, srcName, srcFlags, srcRaidFlags, dstGUID, dstName, dstFlags, dstRaidFlags, ...)
	if UnitIsUnit(dstName, "player") then dstName = UnitName("player") else return end
	if not Recount.db.profile.GlobalDataCollect or not Recount.CurrentDataCollect then return end
	if not Recount:CheckRetentionFromFlags(srcFlags) and not Recount:CheckRetentionFromFlags(dstFlags) then return end
	if srcName == nil then
		srcName = "No One"
	else
		Recount:MatchGUID(srcName, srcGUID, srcFlags)
	end
	if dstName == nil then
		dstName = "No One"
	else
		Recount:MatchGUID(dstName, dstGUID, dstFlags)
	end
	
	mEventList = mEvent[eventtype]
	
	if mEventList then
		mEventList(self, timestamp, eventtype, srcGUID, srcName, srcFlags, dstGUID, dstName, dstFlags, ...)
	end
end

function RecountMitigation:mEventHTD(eventtype, unitId, spellName, rank, lineId, spellId, timestamp)
	if UnitIsUnit(unitId, "player") then unitId = UnitName("player") else return end
	if not mBuffsHTD[spellId] then return end
	RecountMitigation:mBuffApplied(time(), eventtype, srcGUID, unitId, srcFlags, dstGUID, unitId, dstFlags, spellId, spellName, spellSchool, auraType, amount)
end

local math_floor = math.floor
function RecountMitigation:Round100(num)
	return math_floor((num * 100) + 0.5) / 100
end
----------------------------------------------------------------------
--																	--
--  FUNCTION : REMOVE DR BUFF										--
--																	--
----------------------------------------------------------------------
function RecountMitigation:RemoveDRBuff(timestamp, dstName, spellId, spellName, srcName)
	local dstDRBuffs = mActive[dstName]
	if not dstDRBuffs or not dstDRBuffs[spellId] then return end
	--print("Remove:mActive[", dstName, "][", spellId, "] = ", nil)
	mActive[dstName][spellId] = nil
end
----------------------------------------------------------------------
--																	--
--  FUNCTION : SORT DAMAGE REDUCTION								--
--																	--
----------------------------------------------------------------------
function RecountMitigation:SortDR(source, victim, spellName, spellSchool, damage, spellId, timestamp, absorbed, blocked, resisted)
	if UnitIsUnit(victim, "player") then victim = UnitName("player") end
	if UnitIsUnit(source, "player") then source = UnitName("player") end
	if spellName == nil then
		--print("spellName Unknown - spellId: ", spellId)
		spellName = "Unknown"
	end
	--------------
	-- BLOCKED	--
	--------------
	if blocked ~= nil then
		RecountMitigation:AddDR(source, damage, "Blocked", blocked, "Blocked", victim)
	end
	--------------
	-- ABSORBED	--
	--------------
	if absorbed ~= nil then
		RecountMitigation:AddDR(source, damage, "Absorbed", absorbed, "Absorbed", victim)
	end
	--------------
	-- RESISTED	--
	--------------
	if resisted ~= nil then
		RecountMitigation:AddDR(source, damage, "Resisted", resisted, "Resisted", victim)
	end	
	---------------------------
	-- DAMAGE REDUCTION BUFF --
	---------------------------
	local dstDRBuffs = mActive[victim]
	if not dstDRBuffs then return end
	if damage <= 0 then return end
	
	for drSpellId, drBuffed in pairs(dstDRBuffs) do
		if not drBuffed then return end
		--WILL NOT WORK FOR MULTIPLE BUFFS AT THE SAME TIME
		drAmount = RecountMitigation:CalDR(drSpellId, spellSchool, damage)
		if drAmount > 0 then
			damage = damage + (blocked or 0) + (absorbed or 0) + (resisted or 0)
			local drSpellName = GetSpellInfo(drSpellId)
			RecountMitigation:AddDR(source, damage, spellName, drAmount, drSpellName, victim)
		end
	end
end
----------------------------------------------------------------------
--																	--
--  FUNCTION : ADD DAMAGE REDUCTION									--
--																	--
----------------------------------------------------------------------
function RecountMitigation:AddDR(source, damage, spellName, drAmount, drSpellName, victim)
	damage = damage + drAmount
	if Recount.db2.combatants[victim] then
		local sourceData = Recount.db2.combatants[victim]
		Recount:AddAmount(sourceData, "TotalDamageMitigation", drAmount)
		Recount:AddTableDataStats(sourceData, "DamageMitigation", spellName, victim, drAmount)
		Recount:AddTableDataStats(sourceData, "DamageReducedBy", drSpellName, victim, drAmount)
		Recount:AddTableDataStats(sourceData, "ProtectedWho", victim, drSpellName, drAmount)
	end
end
----------------------------------------------------------------------
--																	--
--  FUNCTION : CALCULATE DAMAGE REDUCTION							--
--																	--
----------------------------------------------------------------------
function RecountMitigation:CalDR(drSpellId, spellSchool, damage)
	local dm
	dm = mBuffAll[drSpellId]
	if (not dm) and spellSchool == SPELLSCHOOL_PHYSICAL and mBuffPhysical[drSpellId] then
		dm = mBuffPhysical[drSpellId]
	end
	if (not dm) and spellSchool ~= SPELLSCHOOL_PHYSICAL and mBuffMagical[drSpellId] then
		dm = mBuffMagical[drSpellId]
	end
	if (not dm) and spellSchool == SPELLSCHOOL_PHYSICAL and mBuffPhysicalHTD[drSpellId] then
		dm = mBuffPhysicalHTD[drSpellId]
	end
	if (not dm) and spellSchool ~= SPELLSCHOOL_PHYSICAL and mBuffMagicalHTD[drSpellId] then
		dm = mBuffMagicalHTD[drSpellId]
	end
	if (not dm) and mBuffAllHTD[drSpellId] then
		dm = mBuffAllHTD[drSpellId]
	end
	
	if not dm then return 0	end
	--DEBUG
	--Override dm
		if spellId == 132403 then -- Shield of the Righteous
			--print("spellName: ", spellName, "spellId: ", spellId)
			dm = mBuffPhysical[132403]+(GetMastery()/100)
		end
	--DEBUG
	
	origDamage = damage / (1.0 - dm)
	return math_floor(origDamage - damage + 0.5)
end

function RecountMitigation:DataModesDamageMitigation(data, num)
	if not data then return 0, 0 end
	if num == 1 then
		return RecountMitigation:Round100((data.Fights[Recount.db.profile.CurDataSet].TotalDamageMitigation or 0), (data.Fights[Recount.db.profile.CurDataSet].TotalDamageMitigation or 0)/((data.Fights[Recount.db.profile.CurDataSet].ActiveTime or 0) + Epsilon))
	else
		return (data.Fights[Recount.db.profile.CurDataSet].TotalDamageMitigation or 0), {{data.Fights[Recount.db.profile.CurDataSet].DamageReducedBy, " "..L["'s Damage Mitigation Abilities"], DetailTitles.DamageReducedBy}, {data.Fights[Recount.db.profile.CurDataSet].DamageMitigation, L["'s Damage Mitigation"], DetailTitles.DamageMitigation}}
	end
end


function RecountMitigation:TooltipFuncsDamageMitigation(name, data)
	GameTooltip:ClearLines()
	GameTooltip:AddLine(name)
	tTotal = {}
	tTotal[L["Total Damage"]] = {}
	tTotal[L["Total Damage"]]["amount"] = data.Fights[Recount.db.profile.CurDataSet].DamageTaken + data.Fights[Recount.db.profile.CurDataSet].TotalDamageMitigation
	Recount:AddSortedTooltipData("Damage Total", tTotal,1)
	GameTooltip:AddLine("")
	tBreakdown = {}
	tBreakdown[L["Total Damage Taken"]] = {}
	tBreakdown[L["Total Damage Mitigated"]] = {}
	tBreakdown[L["Total Damage Taken"]]["amount"] = data.Fights[Recount.db.profile.CurDataSet].DamageTaken
	tBreakdown[L["Total Damage Mitigated"]]["amount"] = data.Fights[Recount.db.profile.CurDataSet].TotalDamageMitigation
	Recount:AddSortedTooltipData(L["Damage Breakdown"], tBreakdown,2)
	GameTooltip:AddLine("")
	Recount:AddSortedTooltipData(RL["Top 3"].." "..L["Damage Mitigation Abilities"], data and data.Fights[Recount.db.profile.CurDataSet] and data.Fights[Recount.db.profile.CurDataSet].DamageReducedBy, 3)
	GameTooltip:AddLine("<"..RL["Click for more Details"]..">",0,0.9,0)
end

Recount:AddModeTooltip(L["Damage Mitigation"], RecountMitigation.DataModesDamageMitigation, RecountMitigation.TooltipFuncsDamageMitigation, nil,nil,nil,nil)